function Gn = G1(alpha,x0,y0,z0,rNs,n,N,zS,ztol)    

ufunc = @(th,r) ((1-N)*(rNs(2)^2-r.*r)+N*(r.*r-rNs(1)^2)) ...
                /(rNs(2)^2-rNs(1)^2).*(r.^n).*cos(n*th);

x = @(th,r) r.*cos(th)/cos(alpha)+zS*tan(alpha);
y = @(th,r) r.*sin(th);

r0 = x0*cos(alpha)-z0*sin(alpha);
th0 = atan2(y0,r0);
r0 = sqrt(r0*r0+y0*y0);

rho = @(th,r) sqrt((x(th,r)-x0).^2+(y(th,r)-y0).^2+(zS-z0)^2);
rhop = @(th,r) sqrt((x(th,r)-x0).^2+(y(th,r)-y0).^2+(zS+z0)^2);
G = @(th,r) 1./rho(th,r)/4/pi+1./rhop(th,r)/4/pi;

dth = 5e-3;
dr = min(1e-3,abs(rNs(2)-rNs(1))/5);
func = @(th,r) G(th,r).*ufunc(th,r).*r/cos(alpha);
if r0-rNs(1)>dr && rNs(2)-r0>dr && (abs(zS-z0)<ztol || abs(zS+z0)<ztol) 
    Gn = integral2(func,th0+dth,th0+pi*2-dth,rNs(1),rNs(2)) ...
        +integral2(func,th0-dth,th0,rNs(1),r0) ...
        +integral2(func,th0,th0+dth,rNs(1),r0) ...
        +integral2(func,th0-dth,th0,r0,rNs(2)) ...
        +integral2(func,th0,th0+dth,r0,rNs(2));
else
    Gn = integral2(func,th0+dth,th0+pi*2-dth,rNs(1),rNs(2)) ...
        +integral2(func,th0-dth,th0,rNs(1),rNs(2)) ...
        +integral2(func,th0,th0+dth,rNs(1),rNs(2));
end

end
