function Gn = phi2ur2(alpha,a,b,nc,Nx1,Nx2,My,rn)

r1 = rn(1);
r2 = rn(2);

dNx = Nx2-Nx1+1;
phics = zeros(dNx*My*2,1);
for na=0:dNx-1
    for mb=0:My-1
        kx = (na+Nx1)*pi/a;
        ky = mb*pi/b;
        kz = sqrt(kx*kx+ky*ky);
        phi = atan(ky*cos(alpha)/kx);
        lambc = sqrt((kx/cos(alpha))^2+ky*ky);
        
        if (kx+ky)>1e-12
            fint = r2^(nc+2)*besselj(nc+2,lambc*r2);
            fint = r1^(nc+2)*besselj(nc+2,lambc*r1)-fint;
            fint = fint*2/(lambc*lambc)/(r2*r2-r1*r1);
            fint = fint+r2^(nc+1)*besselj(nc+1,lambc*r2)/lambc;
            if mod(nc,2)==0
                % cosx-cosy
                fint = fint*2*((1i)^nc)*pi*cos(nc*phi)/cos(alpha);
                if abs(fint)<1e-12
                    fint = 0;
                end
                phics(na*My+mb+1) = fint/a/b/kz;
            else
                % sinx-cosy
                fint = fint*2*((1i)^(nc-1))*pi*cos(nc*phi)/cos(alpha);
                if abs(fint)<1e-12
                    fint = 0;
                end
                phics(dNx*My+na*My+mb+1) = fint/a/b/kz;
            end         
        end
    end
end

Gn = phics;
end
