clear;
clc;

controlDict;
Be = zeros(ncount3,1);
Aephi = zeros(ncount3,dof2+dof4);
parfor np = 1:ncount3
    fprintf('face 3 collocation point %d\n',np);
    xp = xpf3(np);
    yp = ypf3(np);
    zp = zpf3(np);
    rp = xp*cos(alpha)-zp*sin(alpha);
    xip = xp*sin(alpha)+zp*cos(alpha);
    thp = atan2(yp,rp);
    rp = sqrt(rp*rp+yp*yp);
    % Ae
    Aphi2 = zeros(1,dof2);
    % face 3 interpolation phi3
    Aphi3 = [];
    for nc = 0:Ncos-1
        Anc = zeros(1,Nr+1);
        for nra = 1:Nr
            rNs = Rnodes(nra:nra+1);
            if abs(rp-rNs(1))<rtol
                ctmp = (rp^nc)*cos(nc*thp);
                Anc(nra) = Anc(nra)+ctmp;
            elseif rp-rNs(1)>rtol && rNs(2)-rp>rtol
                ctmp = (rNs(2)^2-rp^2)/(rNs(2)^2-rNs(1)^2)*(rp^nc)*cos(nc*thp);
                Anc(nra) = Anc(nra)+ctmp;
                ctmp = (rp^2-rNs(1)^2)/(rNs(2)^2-rNs(1)^2)*(rp^nc)*cos(nc*thp);
                Anc(nra+1) = Anc(nra+1)+ctmp;
            end
        end
        Aphi3 = [Aphi3 Anc];
    end
    % assemble Aephi
    Aephi(np,:) = [Aphi2 Aphi3]*wf3(np);  
end

save('M3phi.mat','Be','Aephi');
