function Gn = dG1r(alpha,x0,y0,z0,xiNs,xilim,n,N,rtol,ztol)    

phifunc = @(th,xi) ((1-N)*(xiNs(2)-xi)+N*(xi-xiNs(1)))/(xiNs(2)-xiNs(1)).*cos(n*th);

x = @(th,xi) cos(th)/cos(alpha)+xi*sin(alpha);
y = @(th) sin(th);
z = @(th,xi) xi*cos(alpha);

r0 = x0*cos(alpha)-z0*sin(alpha);
xi0 = x0*sin(alpha)+z0*cos(alpha);
xi0 = xi0-r0*tan(alpha);
th0 = atan2(y0,r0);
r0 = sqrt(r0*r0+y0*y0);
if abs(r0-1)<rtol
    r0 = 1;
end

rho = @(th,xi) sqrt((x(th,xi)-x0).^2+(y(th)-y0).^2+(z(th,xi)-z0).^2);
rhop = @(th,xi) sqrt((x(th,xi)-x0).^2+(y(th)-y0).^2+(z(th,xi)+z0).^2);
dG1 = @(th) 1-r0*cos(th-th0);
dG2 = @(th) 1-((x0*cos(alpha)+z0*sin(alpha))*cos(th)+y0*sin(th));
dGdr = @(th,xi) -(dG1(th)./(rho(th,xi).^3)+dG2(th)./(rhop(th,xi).^3))/4/pi; 
func = @(th,xi) phifunc(th,xi).*dGdr(th,xi);

drth = min(5e-3,abs((xilim(2)-xilim(1)))/5);
if abs(r0-1)<rtol && xi0-xilim(1)>ztol && xilim(2)-xi0>ztol
    Gn = integral2(func,th0+drth,th0+pi*2-drth,xilim(1),xilim(2)) ...
         +integral2(func,th0-drth,th0,xilim(1),xi0) ...
         +integral2(func,th0-drth,th0,xi0,xilim(2)) ...
         +integral2(func,th0,th0+drth,xilim(1),xi0) ...
         +integral2(func,th0,th0+drth,xi0,xilim(2));
else
    Gn = integral2(func,th0,th0+drth,xilim(1),xilim(2)) ...
         +integral2(func,th0+drth,th0+pi,xilim(1),xilim(2)) ...
         +integral2(func,th0-drth,th0,xilim(1),xilim(2))...
         +integral2(func,th0-pi,th0-drth,xilim(1),xilim(2));
end

end
