clear;
clc;

controlDict;
addpath('./Integrals');
B2 = zeros(ncount2,1);
A2 = zeros(ncount2,dof1+dof2+dof4);

% matrix components for face 2 collocation points
fprintf('face 2 np:%d  dof1: %d  dof2:%d  dof4:%d\n',ncount2,dof1,dof2,dof4);
parfor np = 1:ncount2
    fprintf('face 2 collocation point %d\n',np);
    xp = xpf2(np);
    yp = ypf2(np);
    zp = zpf2(np);
    rp = xp*cos(alpha)-zp*sin(alpha);
    xip = xp*sin(alpha)+zp*cos(alpha);
    xip = xip-rp*tan(alpha);
    thp = atan2(yp,rp);
    rp = 1;
    % face 1 integral
    Au1 = [];
    for nc = 0:Ncos-1
        Anc = zeros(1,NrU+1);
        for nra = 1:NrU
            rNs = RnodesU(nra:nra+1);
            Anc(nra) = Anc(nra)+G1(alpha,xp,yp,zp,rNs,nc,0,0,ztol);
            Anc(nra+1) = Anc(nra+1)+G1(alpha,xp,yp,zp,rNs,nc,1,0,ztol);            
        end
        Au1 = [Au1 Anc];
    end
    % face 2 integral
    Aphi2 = [];
    for nc = 0:Ncos-1
        Anc = zeros(1,Nxi+1);
        for nxiN = 1:Nxi
            xiNs = xinodes(nxiN:nxiN+1);
            xilim = xiNs;
            if nxiN==1
                xilim(1) = 0;
            elseif nxiN==Nxi
                xilim(2) = L/cos(alpha);
            end
            Anc(nxiN) = Anc(nxiN)+dG1r(alpha,xp,yp,zp,xiNs,xilim,nc,0,rtol,ztol);
            Anc(nxiN+1) = Anc(nxiN+1)+dG1r(alpha,xp,yp,zp,xiNs,xilim,nc,1,rtol,ztol);
            if nxiN==1 
                if xilim(2)-xip>ztol
                    ctmp = (xiNs(2)-xip)/(xiNs(2)-xiNs(1))*cos(nc*thp);
                    Anc(nxiN) = Anc(nxiN)+ctmp/2;
                    ctmp = (xip-xiNs(1))/(xiNs(2)-xiNs(1))*cos(nc*thp);
                    Anc(nxiN+1) = Anc(nxiN+1)+ctmp/2;
                end
            else
                if abs(xip-xilim(1))<ztol
                    ctmp = cos(nc*thp);
                    Anc(nxiN) = Anc(nxiN)+ctmp/2;
                elseif xip-xilim(1)>ztol && xilim(2)-xip>ztol
                    ctmp = (xiNs(2)-xip)/(xiNs(2)-xiNs(1))*cos(nc*thp);
                    Anc(nxiN) = Anc(nxiN)+ctmp/2;
                    ctmp = (xip-xiNs(1))/(xiNs(2)-xiNs(1))*cos(nc*thp);
                    Anc(nxiN+1) = Anc(nxiN+1)+ctmp/2;
                end
            end
        end
        Aphi2 = [Aphi2 Anc];
    end
    % face 3 integral u3 (u1 image)
    Au3 = [];
    for nc = 0:Ncos-1
        Anc = zeros(1,NrU+1);
        for nra = 1:NrU
            rNs = RnodesU(nra:nra+1);
            Anc(nra) = Anc(nra)-(uimag^nc)*G1(alpha,xp,yp,zp,rNs,nc,0,L,ztol);
            Anc(nra+1) = Anc(nra+1)-(uimag^nc)*G1(alpha,xp,yp,zp,rNs,nc,1,L,ztol);
        end
        Au3 = [Au3 Anc];
    end
    % face 3 integral phi3
    Aphi3 = [];
    for nc = 0:Ncos-1
        Anc = zeros(1,Nr+1);
        for nra = 1:Nr
            rNs = Rnodes(nra:nra+1);
            Anc(nra) = Anc(nra)+dG1z(alpha,xp,yp,zp,rNs,nc,0,L,ztol);
            Anc(nra+1) = Anc(nra+1)+dG1z(alpha,xp,yp,zp,rNs,nc,1,L,ztol);
        end
        Aphi3 = [Aphi3 Anc];
    end
    % assemble
    A2(np,:) = [Au1+Au3 Aphi2 Aphi3]*wf2(np);
end
   
save('M2.mat','B2','A2');
