% impose velocity symmetry
% separate DOF of u1 and phi3
% avoid edge nodes on surface 2
% match edge element size of face2 and face 1 
% integrate M3e

clear;
clc;

alpha = deg2rad(60);    % inclination angle
hP = 2;                 % plate thickness length
Ncos = 4;               % number of azimuthal modes              

L = hP;                  
xiL = L/cos(alpha)-2*tan(alpha); 

NrU = Ncos+4;
Nr = NrU; % Ncos+4;
Nth = Ncos*2;
Nrad = Nr*2;
dxiR = 10;
dxi = 1/Nr/cos(alpha);
Nxi = max(2,round(L/cos(alpha)/dxi));
dxi = L/cos(alpha)/Nxi;
NxiS = Nxi;
dxiS = L/cos(alpha)/NxiS;

polymesh;
ncount1 = size(xpf1,2);
ncount2 = size(xpf2,2);
ncount3 = size(xpf3,2);
dof1 = Ncos*(NrU+1);    % u1  
dof2 = Ncos*(Nxi+1);    % phi2
dof4 = Ncos*(Nr+1);     % phi3

% tolerance parameters
rtol = 1e-8;
ztol = 1e-8;

uimag = -1;
