clear;
clc;

controlDict;
addpath('./Integrals');

nPart = 2;
Nx1 = Nxpar(nPart,1)-1;
Nx2 = Nxpar(nPart,2)-1;
dNx = Nx2-Nx1+1;
fprintf('Nx1: %d  Nx2: %d  My: %d\n',Nx1,Nx2,My);
projectionE;

A1p = zeros(ncount1,dof1);
% matrix components for projection at face 1 collocation points
for nd = 1:dof1
    fprintf('face 1 dof %d\n',nd);
    phi_coeff_nd = phi_u_coeff(:,nd);
    parfor np = 1:ncount1
        % fprintf('face 1 collocation point %d\n',np);
        xp = xpf1(np);
        yp = ypf1(np);
        zp = zpf1(np);
        rp = xp*cos(alpha)-zp*sin(alpha);
        xip = xp*sin(alpha)+zp*cos(alpha);
        thp = atan2(yp,rp);
        rp = sqrt(rp*rp+yp*yp);
        % face 1 projection
        A1p(np,nd) = -phimodes(alpha,xp,yp,zp,aP,bP,Nx1,Nx2,My) ...
                     *phi_coeff_nd*wf1(np);
    end
end
   
A3p = zeros(ncount3,dof1);
AeU = zeros(ncount3,dof1);
% matrix components for projection at face 3 collocation points
for nd = 1:dof1
    fprintf('face 3 dof %d\n',nd);
    phi_coeff_nd = phi_u_coeff(:,nd);
    nce = floor((nd-1)/(NrU+1));
    parfor np = 1:ncount3
        xp = xpf3(np);
        yp = ypf3(np);
        zp = zpf3(np);
        rp = xp*cos(alpha)-zp*sin(alpha);
        xip = xp*sin(alpha)+zp*cos(alpha);
        thp = atan2(yp,rp);
        rp = sqrt(rp*rp+yp*yp);
        % face 3 projection
        temp = (uimag^nce)*phimodes(alpha,xp,yp,zp,aP,bP,Nx1,Nx2,My)*phi_coeff_nd;
        A3p(np,nd) = -temp/2*wf3(np);
        AeU(np,nd) = temp*wf3(np);
    end
end

dataname = strcat('Mp',string(nPart),'.mat');
save(dataname,'A1p','A3p','AeU');

