clear;
clc;

controlDict;
fprintf('Nx: %d  My: %d\n',Nx,My);
load('M1.mat');
load('M2.mat');
load('M3.mat');
load('Mp1.mat');
A1pS = A1p;
A3pS = A3p;
AeUS = AeU;
clear('A1p','A3p','AeU');
for nPsol=2:Npar
    filename = strcat('Mp',string(nPsol),'.mat');
    load(filename);
    A1pS = A1pS+A1p;
    A3pS = A3pS+A3p;
    AeUS = AeUS+AeU;
    clear('A1p','A3p','AeU');
end
load('M3phi.mat');
Ae = [AeUS Aephi];
A1(:,1:dof1) = A1(:,1:dof1)+A1pS;
A3(:,1:dof1) = A3(:,1:dof1)+A3pS;

A = [A1; A2; A3; Ae];
B = [B1; B2; B3; Be];
uPhi = lsqlin(A,B);
uPhi = transpose(uPhi);

xiptsN = [0 xinodes L/cos(alpha)];
u1Modes = uPhi(1:NrU+1);
phi2tmp = uPhi(dof1+1:dof1+Nxi+1);
phi2e3 = uPhi(dof1+dof2+Nr+1);
phi2e1 = (phi2e3-0.5)*(-1)+0.5;
phi2Modes = [phi2e1 phi2tmp phi2e3];
phi3Modes = uPhi(dof1+dof2+1:dof1+dof2+Nr+1);

for nc=1:Ncos-1
    temp = uPhi((NrU+1)*nc+1:(NrU+1)*(nc+1)).*(RnodesU.^nc);
    u1Modes = [u1Modes; temp];
    phi2tmp = uPhi(dof1+(Nxi+1)*nc+1:dof1+(Nxi+1)*(nc+1));
    phi2e3 = uPhi(dof1+dof2+Nr*nc+1+Nr);
    phi2e1 = (-1)^(nc+1)*phi2e3;
    phi2tmp = [phi2e1 phi2tmp phi2e3];
    phi2Modes = [phi2Modes; phi2tmp];
    temp = uPhi(dof1+dof2+(Nr+1)*nc+1:dof1+dof2+(Nr+1)*(nc+1)).*(Rnodes.^nc);
    phi3Modes = [phi3Modes; temp];
end

% flow rate
uflux = 0;
u1Mode0 = u1Modes(1,:);
for i=1:NrU
    ugrad = (u1Mode0(i+1)-u1Mode0(i))/(RnodesU(i+1)^2-RnodesU(i)^2);
    func = @(r) 2*pi*(u1Mode0(i)+ugrad*(r.*r-RnodesU(i).^2)).*r/cos(alpha);
    uflux = uflux+integral(func,RnodesU(i),RnodesU(i+1));
end
uAve = uflux/(pi/cos(alpha));
fprintf('plate thickness: %f          effective length: %.6f\n',hP,-1/uAve*cos(alpha)); 

